#include "Structures.h"

std::istream& operator>>(std::istream& in, Node& node) 
{
    in >> node.id;
    in >> node.coordinates[0] >> node.coordinates[1] >> node.coordinates[2];
    in >> node.isVertex;
    return in;
}

std::ostream& operator<<(std::ostream& out, const Node& node) 
{
    out << node.id 
        << ' ' 
        << node.coordinates[0] 
        << ' ' 
        << node.coordinates[1] 
        << ' ' 
        << node.coordinates[2] 
        << ' ' 
        << node.isVertex;
    return out;
}

std::istream& operator>>(std::istream& in, FiniteElement& element) 
{
    in >> element.id;
    in >> element.MaterialId;
    in >> element.FiniteElementIdList[0] >> element.FiniteElementIdList[1] >> element.FiniteElementIdList[2];
    return in;
}

std::ostream& operator<<(std::ostream& out, const FiniteElement& element) 
{
    out << element.id 
        << ' ' 
        << element.MaterialId 
        << ' ' 
        << element.FiniteElementIdList[0]
        << ' ' 
        << element.FiniteElementIdList[1]
        << ' ' 
        << element.FiniteElementIdList[2];
    return out;
}


std::istream& operator>>(std::istream& in, BoundaryFiniteElement& element) 
{
    in >> element.elementId;
    in >> element.boundaryId;
    in >> element.BoundaryFiniteElementIdList[0] 
        >> element.BoundaryFiniteElementIdList[1] 
        >> element.BoundaryFiniteElementIdList[2] 
        >> element.BoundaryFiniteElementIdList[3];
    return in;
}

std::ostream& operator<<(std::ostream& out, const BoundaryFiniteElement& element) 
{
    out << element.elementId
        << ' '
        << element.boundaryId
        << ' '
        << element.BoundaryFiniteElementIdList[0]
        << ' '
        << element.BoundaryFiniteElementIdList[1]
        << ' '
        << element.BoundaryFiniteElementIdList[2]
        << ' '
        << element.BoundaryFiniteElementIdList[3];
    return out;
}

Edge::Edge(size_t a, size_t b) : 
    nodePair(std::make_pair(a, b)) 
{}

bool Edge::operator==(const Edge& a) const 
{
    return (nodePair.first == a.nodePair.first) && (nodePair.second == a.nodePair.second);
}
