#pragma once
#include <iostream>
#include <vector>
#include <set>
#include <array>
#include <unordered_map>

class Node 
{
public:
    size_t id;
    std::array<double, 3> coordinates;
    bool isVertex = false;

    Node() = default;
    friend std::istream& operator>>(std::istream&, Node&);
    friend std::ostream& operator<<(std::ostream&, const Node&);
};

class FiniteElement 
{
public:
    size_t id;
    size_t MaterialId;
    std::vector<size_t> FiniteElementIdList;

    FiniteElement() = default;
    FiniteElement(const FiniteElement&) = default;
    friend std::istream& operator>>(std::istream&, FiniteElement&);
    friend std::ostream& operator<<(std::ostream&, const FiniteElement&);

};

class BoundaryFiniteElement 
{
public:
    size_t elementId;
    size_t boundaryId;
    std::vector<size_t> BoundaryFiniteElementIdList;

    friend std::istream& operator>>(std::istream&, BoundaryFiniteElement&);
    friend std::ostream& operator<<(std::ostream&, const BoundaryFiniteElement&);
};

class Edge 
{
public:
    std::pair<size_t, size_t> nodePair;
    size_t centerNode;

    Edge(size_t, size_t);
    bool operator==(const Edge&) const;
};

