#include <iostream>
#include <set>
#include "Structures.h"
#include "AneuMeshLoader.h"

int main() 
{
    MeshLoader* loader = new AneuMeshLoader;
    loader->loadMesh("cube.aneu");
    const auto& nodeSTL = loader->getNodeSTL();
    const auto& finiteSTL = loader->getFiniteSTL();
    const auto& boundarySTL = loader->getBoundarySTL();

    auto elementById = loader->findFiniteElementById(0, 0, 0);
    auto elementByEdge = loader->findFiniteElementByEdge(1, 0);

    auto FEByType = loader->getFiniteElementByMaterial(1);
    auto nodesByBoundary = loader->getNodeSTLByBoundaryId(3);
    auto BFEByBoundary = loader->getBoundaryFiniteElementSTLByBoundaryId(1);
    auto neighbours = loader->getNeighbourSTL();

    loader->insertNodesInCenter(finiteSTL[3], 1, 2);

    delete loader;
    return 0;
}
